// Demo Code 4/1/14
// Defining and using a class

Target t1, t2;
boolean shotFlag, checkHitFlag;
int animateShotCounter;
int shotX, shotY;

void setup( )
{
  size( 800, 500 );
  noStroke( );
  background( 0 );
  
  textSize( 36 );
  textAlign( CENTER );
  
  t1 = new Target( int( random( 50, height/2 )), 25   );
  t2 = new Target( int( random( height*.6, height-50 )), 40  );
  
  shotFlag = false;
  checkHitFlag = false;
  animateShotCounter = 0;
  shotX = shotY = 0;
}

void draw( )
{
  t1.drawTarget( );
  t2.drawTarget( );
  if ( shotFlag )
  {
    animateShot( );
  }
  if( checkHitFlag )
  {
    checkShot( );
  }
}

void animateShot( )
{
  if ( animateShotCounter < 100 &&
       shotX < t1.targetX )
  {
    fill( 255, 255, 0 );
    ellipse( shotX, shotY, 20, 5 );
    shotX += width/100;
    animateShotCounter++;
  }
  else
  {
     shotFlag = false;
     checkHitFlag = true; 
     shotX = 0;
  }
}

void checkShot( )
{
   if (t1.gotHit( shotY ) )
   {
       checkHitFlag = false;
       shotX = 0;
       shotY = -50;
       fill( 255, 0, 0 );
       rect( 0, 0, width, height );
       fill( 0 );
       text( "Target #1 hit!", width/2, height/2 );
       text( "Press any key to continue.", width/2, height * .65 );
       noLoop( );
   } 
   else if ( t2.gotHit( shotY ) )
   {
       checkHitFlag = false;
       shotX = 0;
       shotY = -50;
       fill( 0, 0, 255 );
       rect( 0, 0, width, height );
       fill( 255 );
       text( "Target #2 hit", width/2, height/2 );
       noLoop( );
   }   
}

void mousePressed( )
{
  shotFlag = true;
  checkHitFlag = false;
  shotY = mouseY;
  shotX = 0;
  animateShotCounter = 0;
}

void keyPressed( )
{
  background( 0 );
  
  t1 = new Target( int( random( 50, height/2 )), 25   );
  t2 = new Target( int( random( height*.6, height-50 )), 40  );
  
  shotFlag = false;
  checkHitFlag = false;
  animateShotCounter = 0;
  shotX = shotY = 0;
  
  loop( );
}
