// Demo Code B 4/1/14
// Defining and using two classes:  target and shot

Target t1, t2;
Shot s1;
boolean checkHitFlag;


void setup( )
{
  size( 800, 500 );
  noStroke( );
  background( 0 );
  
  textSize( 36 );
  textAlign( CENTER );
  
  t1 = new Target( int( random( 50, height/2 )), 50   );
  t2 = new Target( int( random( height*.6, height-50 )), 80  );
  
  s1 = new Shot( );
  
  checkHitFlag = false;
}

void draw( )
{
  t1.drawTarget( );
  t2.drawTarget( );
  if ( s1.shotFlag )
  {
    s1.animateShot( );
  }
  if( checkHitFlag )
  {
    checkShot( );
  }
}

void checkShot( )
{
   if (t1.gotHit( s1.shotY ) )
   {
       checkHitFlag = false;
       s1.shotX = 0;
       s1.shotY = -50;
       fill( 255, 0, 0 );
       rect( 0, 0, width, height );
       fill( 0 );
       text( "Target #1 hit!", width/2, height/2 );
       text( "Press any key to continue.", width/2, height * .65 );
       noLoop( );
   } 
   else if ( t2.gotHit( s1.shotY ) )
   {
       checkHitFlag = false;
       s1.shotX = 0;
       s1.shotY = -50;
       fill( 0, 0, 255 );
       rect( 0, 0, width, height );
       fill( 255 );
       text( "Target #2 hit", width/2, height/2 );
       noLoop( );
   }
   
}

void mousePressed( )
{
  s1.shotFlag = true;
  checkHitFlag = false;
  s1.shotY = mouseY;
  s1.shotX = 0;
  s1.animateShotCounter = 0;
}

void keyPressed( )
{
  background( 0 );
  
  t1 = new Target( int( random( 50, height/2 )), 25   );
  t2 = new Target( int( random( height*.6, height-50 )), 40  );
  
  s1.shotFlag = false;
  checkHitFlag = false;
  s1.animateShotCounter = 0;
  s1.shotX = s1.shotY = 0;
  
  loop( );
}
